#define BLACK_BG      0
#define BLUE_BG       16
#define GREEN_BG      32
#define CYAN_BG       48
#define RED_BG        64
#define MAGENTA_BG    80
#define BROWN_BG      96
#define LIGHTGRAY_BG  112
#define BLACK         0
#define BLUE          1
#define GREEN         2
#define CYAN          3
#define RED           4
#define MAGENTA       5
#define BROWN         6
#define LIGHTGRAY     7
#define DARKGRAY      8
#define LIGHTBLUE     9
#define LIGHTGREEN    10
#define LIGHTCYAN     11
#define LIGHTRED      12
#define LIGHTMAGENTA  13
#define YELLOW        14
#define WHITE         15
#define BLINK         128

#define UP            0x06      /* scrolling direction */
#define DOWN          0x07      /* scrolling direction */

char init_video(void);
void clrscr(void);
int getkey(void);
void hidecursor(void);
void showcursor(void);
void gotoxy(unsigned char xpos, unsigned char ypos);
void cputs(char far *str);
void gettext(unsigned char left, unsigned char top, unsigned char right,
             unsigned char bottom, void far *destin);
void puttext(unsigned char left, unsigned char top, unsigned char right,
             unsigned char bottom, void far *source);
void cprintf(char *format, ...);
void textattr(unsigned char attr);
void window(unsigned char left, unsigned char top, unsigned char right,
            unsigned char bottom);
void framewin(unsigned char attr);
unsigned char wherey(void);
void wtitle(char far *str);
void scroll(unsigned char dir, unsigned char x1, unsigned char y1,
            unsigned char x2, unsigned char y2, unsigned char attr,
            unsigned char num);

void DWriteCH(void);
void DWriteStr(void);
void StoreToMem(void);
void StoreToScr(void);
void DWriteCHVert(void);
